.include	"8515def.inc"
;.DEVICE AT90S8515
; EEPROM
;Sequance_table:
;1-16  , 17-18 - , 19-20 - 
;21 - , 22  on/off (00-,81-On,82-off)
;23-24     (   
;     
;     
;        )
;25 - , 26 - ffh       
;1-1,2-2,3-3,4-4,5-5,6-6,7-7,8-8,9-9,0-10,*-11,#-12,a-13,b-14,-15,d-0
.equ	Position_DTMF_Length	=16
.equ	Position_Pause_Length	=18
.equ	Position_Number_Symbol	=20
.equ	Position_Flag_On	=21
.equ	Position_Timer_Wait	=22
;----------------------
.eseg
.equ	Start_Sequence_Table=0
.org	Start_Sequence_Table
;	 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16, 17,18, 19,20,21,  22, 23, 24, 25, 26
Sequence_table_A:
.db 	 0, 5, 9, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x81,250,  0,255,255
.db 	15, 3, 8,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x81,250,  0,255,255
.db 	13, 3,14, 5, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x81,250,  0,255,255
.db 	 7,10,13, 9,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x81,250,  0,255,255
.db 	 1,14, 4, 5,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x82,250,  0,255,255
.db 	 2, 9, 3,12, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x82,250,  0,255,255
.db 	 4, 5, 6,14,13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x82,250,  0,255,255
.db 	 8,14,11, 3, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x82,250,  0,255,255
Sequence_Table_B:
.db 	 0, 5, 9, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x82,250,  0,255,255
.db 	15, 3, 8,11, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x82,250,  0,255,255
.db 	13, 3,14, 5, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x82,250,  0,255,255
.db 	 7,10,13, 9,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x82,250,  0,255,255
.db 	 1,14, 4, 5,12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x81,250,  0,255,255
.db 	 2, 9, 3,12, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x81,250,  0,255,255
.db 	 4, 5, 6,14,13, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x81,250,  0,255,255
.db 	 8,14,11, 3, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,100, 0, 50, 0, 5,0x81,250,  0,255,255
;-------------------
End_Sequence_table:

Time_DTMF_valid_A:
.db 	31,0	;        A DTMF , +1
Time_DTMF_valid_B:
.db 	31,0	;        B DTMF , +1
;-------------------
Time_DTMF_NOvalid_A:
.db 	21,0	;        A DTMF , +1
Time_DTMF_NOvalid_B:
.db 	21,0	;        B DTMF , +1
;-------------------
Flag_Prioritet:
.db	0,0	;       00-A, FF-B
;-------------------
Mode_A:
.db	0x81,0	;  : 0 , 81h   *, 82h   , 85h,86h-
Mode_B:
.db	0x0,0	;  : 0 , 81h   *, 82h   , 85h,86h-
;-------------------
CopyRight:
.db	"  (c) V*D*V 2002"
;-------------------
;************************************
.equ	Number_Sequence		=16	;  
.equ	Wide_Table		=(End_Sequence_Table-Start_Sequence_Table)/Number_Sequence
.equ	Quartz			=8000	;  
.equ	Drebezg			=100	;   
.equ	PushButton		=1000	;     
.equ	Repeat			=200	;   
.equ	Repeat_Step		=10	;    
.equ	Display_Time		=30000	;       
.equ	MaxTime			=1000	;     
.equ	MinSymbolTime		=70	;   
.equ	MinPauseTime		=5	;   
.equ	Relay_Time		=1000	;   
.equ	Max_SeqSymbol		=16	;     
.equ	Period_Control		=1000	;   
.equ	Period_ControlCorrect	=1000+353;      
.equ	Period_TimeCorrect	=1000	;       
.equ	Key_1			=0x07	; 7.a   1
.equ	Key_2			=0x0b	; 6.a   2
.equ	Key_3			=0x0d	; 7.c   3
.equ	Key_4			=0x0e	; 6.c   4
.equ	Key_1i2			=0x03	; 7.a  6.a     1  2
.equ	AutoKey_No		=0x0f	;   
.equ	AutoKey_1i2		=0x03	;     1  2 
.equ	AutoKey_1i3		=0x05	;     1  3 
;************************************
;    
.DSEG
.org	0x60
Table_Timer:
Timer_Symbol_A:	.byte	Number_Sequence/2*2	;     16 
Timer_Symbol_B:	.byte	Number_Sequence/2*2
Table_Timer_Symbol_End:

Timer_Pause_A:	.byte	Number_Sequence/2*2	;     16 
Timer_Pause_B:	.byte	Number_Sequence/2*2

Timer_Valid_A:	.byte	2			;   DTMF- 2 
Timer_Valid_B:	.byte	2

Timer_NoValid_A:	.byte	2		;    DTMF- 2 
Timer_NoValid_B:	.byte	2

Timer_Drebezg:		.byte	2		;    
Timer_Control:		.byte	2		;      
Timer_PushButton:	.byte	2		;       
Timer_Relay:		.byte	2		;    
Timer_Execute_A:	.byte	2
Timer_Execute_B:	.byte	2

Table_Timer_End:	
;-  
Counter_Equal_A:	.byte	Number_Sequence/2	;   16 
Counter_Equal_B:	.byte	Number_Sequence/2
;   
Counter_TimeCorrect:	.byte	2	;   
Counter_Repeat:		.byte	2	;  
;    
Flag_A_On:		.byte	1
Flag_A_Off:		.byte	1
Flag_B_On:		.byte	1
Flag_B_Off:		.byte	1
;--
End_Decoder_Memory:
;--  
Time_Valid_A_Copy:
Time_NoValid_A_Copy:
Sequence_Copy:		.byte	Wide_Table

MinTime_Tone:
Time_Valid_B_Copy:
Time_NoValid_B_Copy:
Err_Sequence_Copy:	.byte	Wide_Table

Clock_Hour_Copy:
Mode_A_Copy:		.byte	1

Clock_Min_Copy:
Mode_B_Copy:		.byte	1
;--  -
RAM_Screen:		.byte	48
Key:			.byte	1	;  
Flag_AutoRepeat:	.byte	1	;       
Flag_New_Symbol_A:	.byte	1	;     A
Flag_New_Symbol_B:	.byte	1	;     B
;-- 
Clock_Sec:		.byte	1	; 
Clock_Min:		.byte	1	; 
Clock_Hour:		.byte	1	; 
Flag_Clock:		.byte	1	;      
;--
;TestCounter:		.byte	2
;********************************
; 
.def	publik1		=r1
.def	publik2		=r2
.def	publik3		=r3
.def	publik4		=r4
.def	publik5		=r5
.def	publik6		=r6
.def	publik7		=r7
.def	New_Port_A	=r8
.def	New_Port_C	=r9
.def	Old_Port_A	=r10
.def	Old_Port_C	=r11
.def	Old_Key		=r12
.def	edited_ch	=r13
.def	zero		=r14
.def	Status_Copy	=r15

.def	temp1		=r16
.def	temp2		=r17
.def	temp3		=r18
.def	temp4		=r19
.def	temp5		=r20
.def	temp6		=r21
.def	counter		=r22
.def	Flag_NewKey	=r23
.def	Index_L		=r24
.def	Index_H		=r25
.equ	Request_Data_A	=6	;       A
.equ	Request_Data_B	=7	;       B
.equ	Control_Relay	=4	;    
.equ	Control_Relay_1	=3	;     
.equ	RS		=0	;    RS  
.equ	RdnWr		=1	;    R/-W  
.equ	E		=2	;    E  
.equ	Busy		=7	;    BUSY  
.equ	LCD_Light	=5	;    
; 
.equ	Control_Sygnal	=0x20	;      
.equ	Mask_Valid	=0x20	;    DTMF 
.equ	Mask_Get_Symbol	=0x10	;     
;************************************
.cseg
.org	0
		rjmp	Reset
		rjmp	Ext_INT0
		rjmp	Ext_INT1
;		rjmp	Tim2_comp
;		rjmp	Tim2_ovf
		rjmp	Tim1_capt
		rjmp	Tim1_compA
		rjmp	Tim1_compB
		rjmp	Tim1_ovf
		rjmp	Tim0_ovf
		rjmp	SPI_stc
		rjmp	UART_rxc
		rjmp	UART_dre
		rjmp	UART_txc
;		rjmp	ADC_comp
;		rjmp	EE_rdy
		rjmp	ANA_comp
;************************************
;-----
CopyRightRom:
.db	"      ( c ) V * D * V 2 0 0 2    v . 1"
;-----
Reset:
Ext_INT0:
Ext_INT1:
Tim1_capt:

Tim1_compB:
Tim1_ovf:
Tim0_ovf:
SPI_stc:
UART_rxc:
UART_dre:
UART_txc:
ANA_comp:
		ldi		temp1,high(RAMEND)	;0x02
		out		SPH,temp1
		ldi		temp1,low(RAMEND)	;0x5f
		out		SPL,temp1
		clr	zero
		out		WDTCR,zero
		sbi	ACSR,ACD		;  
		out		GIMSK,zero
		out		TIMSK,zero
		out		TCCR1A,zero
		out		TCCR0,zero
		out		TCCR1B,zero
		out		TCNT1H,zero
		out		TCNT1L,zero
		ldi		temp2,Quartz/256
		out		OCR1AH,temp2
		ldi		temp2,Quartz-Quartz/256*256
		out		OCR1AL,temp2
		ldi		temp1,0x20
		out		MCUCR,temp1		; idle mode, sleep enable
;------- 
		ser	temp2
		ldi	temp1,0xc0
		out		DDRA,zero		;  
		out		PORTA,temp1
		out		DDRC,zero
		out		PORTC,temp1
		out		PORTB,zero		;  
		out		DDRB,temp2
		ldi		temp1,0x3f
		out		PORTD,temp1
		out		DDRD,temp2
;  
		ldi		temp2,End_Decoder_Memory
		clr		xh
		ldi		xl,Table_Timer
Clear_Memory:
		st		x+,zero
		cpse	xl,temp2
		rjmp	Clear_Memory
		
		lds	temp1,Clock_Sec
		cpi	temp1,60
		brcs	Check_Time_1
		sts	Clock_Sec,zero
Check_Time_1:
		lds	temp1,Clock_Min
		cpi	temp1,60
		brcs	Check_Time_2
		sts	Clock_Min,zero
Check_Time_2:
		lds	temp1,Clock_Hour
		cpi	temp1,24
		brcs	Check_Time_3
		sts	Clock_Hour,zero
Check_Time_3:
		ldi	xl,low(Period_TimeCorrect)
		ldi	xh,high(Period_TimeCorrect)
		ldi	yh,high(Period_Control)
		ldi	yl,low(Period_Control)

		sts	Counter_TimeCorrect,xl
		sts	Counter_TimeCorrect+1,xh
		sts		Timer_Control,yl
		sts		Timer_Control+1,yh
		
		mov		Old_Port_A,zero
		mov		Old_Port_C,zero
;--
		ldi		temp1,0x09
		out		TCCR1B,temp1
		ldi		temp1,0x40
		out		TIMSK,temp1	;    1- 
		sei
		ldi	temp1,0x08
		wdr
		out	WDTCR,temp1	;  WDT
		
;		sts	TestCounter,zero
;		sts	TestCounter+1,zero
		
		rjmp	Main
;**************************************
Tim1_compA:
;----	 
		wdr
		in	Status_Copy,SREG
		push	temp1
		push	temp2
		push	temp3
		push	temp4
;		push	temp5
		push	temp6
		push	xl
		push	xh
		push	yl
		push	yh
		push	zl
		push	zh
;---------  
		clr		xh
		ldi		xl,Table_Timer
Timer_Decrement:
		ld		yl,x+
		ld		yh,x
		mov		publik1,yl
		or		publik1,yh
		cpse	publik1,zero
		sbiw	yl,1
		st		x,yh
		st		-x,yl
		adiw	xl,2
		cpi	xl,Table_Timer_End
		brne	Timer_Decrement
;-----------    A  B
		in		New_Port_A,PINA
		in		New_Port_C,PINC
;------------    DTMF     Valid,  NoValid
;    
		sbic	EECR,EEWE
		rjmp	Test_Timer_Valid_A
Test_Valid_A:
		mov		temp1,Old_Port_A
		eor		temp1,New_Port_A
		andi	temp1,Mask_Valid
		breq	Test_Valid_B			;---->
		and		temp1,New_Port_A
		breq	Start_Timer_NoValid_A		;---->
;
		ldi		temp1,high(Time_DTMF_Valid_A)
		out		EEARH,temp1
		ldi		temp1,low(Time_DTMF_Valid_A)
		out		EEARL,temp1
		sbi		EECR,EERE
		in		temp1,EEDR

		sts		Timer_Valid_A,temp1
;		sts		Timer_Valid_A+1,zero
		sts		Timer_NoValid_A,zero
;		sts		Timer_NoValid_A+1,zero
		rjmp	Test_Valid_B
Start_Timer_NoValid_A:
		ldi		temp1,high(Time_DTMF_NoValid_A)
		out		EEARH,temp1
		ldi		temp1,low(Time_DTMF_NoValid_A)
		out		EEARL,temp1
		sbi		EECR,EERE
		in		temp1,EEDR
		sts		Timer_NoValid_A,temp1
;		sts		Timer_NoValid_A+1,zero
		sts		Timer_Valid_A,zero
;		sts		Timer_Valid_A+1,zero
;---  
		ldi		xh,high(Timer_Pause_A)
		ldi		xl,low(Timer_Pause_A)
		ldi		yh,high(Sequence_table_A+Position_Pause_Length)
		ldi		yl,low(Sequence_table_A+Position_Pause_Length)
		ldi	temp2,Number_Sequence/2
Start_Pause_A_1:
		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
		in		temp3,EEDR
		
		adiw	yl,1
		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
		in		temp4,EEDR
		
		add	temp3,temp1
		adc	temp4,zero
		st	x+,temp3
		st	x+,temp4
		
		adiw	yl,Wide_Table-1
		dec	temp2
		brne	Start_Pause_A_1
		
Test_Valid_B:
		mov		temp1,Old_Port_C
		eor		temp1,New_Port_C
		andi	temp1,Mask_Valid
		breq	Test_Timer_Valid_A	;--------->
		and		temp1,New_Port_C
		breq	Start_Timer_NoValid_B	;--------->
;
		ldi		temp1,high(Time_DTMF_Valid_B)
		out		EEARH,temp1
		ldi		temp1,low(Time_DTMF_Valid_B)
		out		EEARL,temp1
		sbi		EECR,EERE
		in		temp1,EEDR
		sts		Timer_Valid_B,temp1
;		sts		Timer_Valid_B+1,zero
		sts		Timer_NoValid_B,zero
;		sts		Timer_NoValid_B+1,zero
		rjmp	Test_Timer_Valid_A
Start_Timer_NoValid_B:
		ldi		temp1,high(Time_DTMF_NoValid_B)
		out		EEARH,temp1
		ldi		temp1,low(Time_DTMF_NoValid_B)
		out		EEARL,temp1
		sbi		EECR,EERE
		in		temp1,EEDR
		sts		Timer_NoValid_B,temp1
;		sts		Timer_NoValid_B+1,zero
		sts		Timer_Valid_B,zero
;		sts		Timer_Valid_B+1,zero

		ldi		xh,high(Timer_Pause_B)
		ldi		xl,low(Timer_Pause_B)
		ldi		yh,high(Sequence_table_B+Position_Pause_Length)
		ldi		yl,low(Sequence_table_B+Position_Pause_Length)
		ldi	temp2,Number_Sequence/2
Start_Pause_B_1:
		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
		in		temp3,EEDR
		
		adiw	yl,1
		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
		in		temp4,EEDR
		
		add	temp3,temp1
		adc	temp4,zero
		st	x+,temp3
		st	x+,temp4
		
		adiw	yl,Wide_Table-1
		dec	temp2
		brne	Start_Pause_B_1

;-------  Valid   ,    
Test_Timer_Valid_A:
		lds		temp1,Timer_Valid_A
		cpi		temp1,1
		brne	Test_Timer_Valid_B
		sbi		PORTD,Request_Data_A
Test_Timer_Valid_B:
		lds		temp1,Timer_Valid_B
		cpi		temp1,1
		brne	Test_Timer_NoValid_A
		sbi		PORTD,Request_Data_B
;-------- NoValid   ,    
Test_Timer_NoValid_A:
		lds		temp1,Timer_NoValid_A
		cpi		temp1,1
		brne	Test_Timer_NoValid_B
		cbi		PORTD,Request_Data_A
		
		lds	temp1,Timer_Execute_A
		lds	temp2,Timer_Execute_A+1
		or	temp1,temp2
		breq	Test_Timer_NoValid_B
		
		sbic	EECR,EEWE
		rjmp	Test_Timer_NoValid_B
		
;  0-off, 81h-*, 82h-
		ldi		temp1,high(Mode_A)
		out		EEARH,temp1
		ldi		temp1,low(Mode_A)
		out		EEARL,temp1
		sbi		EECR,EERE

		sbis	EEDR,0
		rjmp	Test_Timer_NoValid_B	;---->      *	
		ldi		temp1,1		;  
		sts	Timer_Execute_A,temp1
		sts	Timer_Execute_A+1,zero

Test_Timer_NoValid_B:
		lds		temp1,Timer_NoValid_B
		cpi		temp1,1
		brne	Test_Timers_Symbol
		cbi		PORTD,Request_Data_B
		lds	temp1,Timer_Execute_B
		lds	temp2,Timer_Execute_B+1
		or	temp1,temp2
		breq	Test_Timers_Symbol
		
		sbic	EECR,EEWE
		rjmp	Test_Timers_Symbol
		
;  0-off, 81h-*, 82h-
		ldi		temp1,high(Mode_B)
		out		EEARH,temp1
		ldi		temp1,low(Mode_B)
		out		EEARL,temp1
		sbi		EECR,EERE

		sbis	EEDR,0
		rjmp	Test_Timers_Symbol	;---->      *	
		ldi		temp1,1		;  
		sts	Timer_Execute_B,temp1
		sts	Timer_Execute_B+1,zero

;-------   . =0   
Test_Timers_Symbol:
		ldi		xh,high(Table_Timer)
		ldi		xl,low(Table_Timer)
		ldi		yh,high(Counter_Equal_A)
		ldi		yl,low(Counter_Equal_A)
		ldi		zl,Number_Sequence		;   
Test_Timers_Symbol_1:
		ld		temp1,x+
		ld		temp2,x+
		or		temp1,temp2
		brne	Test_Timers_Symbol_2
		st		y,temp1
Test_Timers_Symbol_2:
		adiw	yl,1
		dec		zl
		brne	Test_Timers_Symbol_1
;    
		sbic	EECR,EEWE
		rjmp	Test_Relay_Sygnal
;----       A
		mov		temp1,Old_Port_A
		eor		temp1,New_Port_A
		andi	temp1,Mask_Get_Symbol
;		breq	Test_Get_Symbol_B
		and		temp1,New_Port_A
		breq	Test_Get_Symbol_B
;----   A
;
;		ser	temp3
		ldi	temp3,15
		sts	Flag_New_Symbol_A,temp3
		mov		publik7,New_Port_A
		and	publik7,temp3
		ldi		xh,high(Timer_Pause_A)		; -     
		ldi		xl,low(Timer_Pause_A)		;     
		ldi		yh,high(Sequence_table_A)
		ldi		yl,low(Sequence_table_A)
		ldi		zh,high(Timer_Symbol_A)
		ldi		zl,low(Timer_Symbol_A)
		ldi		Index_H,high(Counter_Equal_A)
		ldi		Index_L,low(Counter_Equal_A)
		
		lds		publik5,Flag_A_On
		lds		publik6,Flag_A_Off
		lds		temp3,Timer_Execute_A
		lds		temp4,Timer_Execute_A+1
		
		ldi		temp6,high(Mode_A)
		out		EEARH,temp6
		ldi		temp6,low(Mode_A)
		out		EEARL,temp6
		sbi		EECR,EERE
		in		temp6,EEDR
		
		rcall		Test_Sequence
		
		sts		Flag_A_On,publik5
		sts		Flag_A_Off,publik6
		sts		Timer_Execute_A,temp3
		sts		Timer_Execute_A+1,temp4
		
;----       B
Test_Get_Symbol_B:
		mov		temp1,Old_Port_C
		eor		temp1,New_Port_C
		andi	temp1,Mask_Get_Symbol
;		breq	End_All_Test
		and		temp1,New_Port_C
		breq	End_All_Test
;----   B
;
;
;		ser	temp3
		ldi	temp3,15
		sts	Flag_New_Symbol_B,temp3
		mov		publik7,New_Port_C
		and	publik7,temp3
		
		ldi		xh,high(Timer_Pause_B)		; -     
		ldi		xl,low(Timer_Pause_B)		;     
		ldi		yh,high(Sequence_table_B)
		ldi		yl,low(Sequence_table_B)
		ldi		zh,high(Timer_Symbol_B)
		ldi		zl,low(Timer_Symbol_B)
		ldi		Index_H,high(Counter_Equal_B)
		ldi		Index_L,low(Counter_Equal_B)
		
		lds		publik5,Flag_B_On
		lds		publik6,Flag_B_Off
		lds		temp3,Timer_Execute_B
		lds		temp4,Timer_Execute_B+1
		
		ldi		temp6,high(Mode_B)
		out		EEARH,temp6
		ldi		temp6,low(Mode_B)
		out		EEARL,temp6
		sbi		EECR,EERE
		in		temp6,EEDR
		
		rcall		Test_Sequence
		
		sts		Flag_B_On,publik5
		sts		Flag_B_Off,publik6
		sts		Timer_Execute_B,temp3
		sts		Timer_Execute_B+1,temp4
;========================================
;------    
End_All_Test:
;--------    
		clr		publik1
		clr		publik2
		clr		publik3
		clr		publik4
		ser	temp3
		
		lds		xl,Timer_Execute_A
		lds		xh,Timer_Execute_A+1
		sbiw		xl,1
		or		xl,xh
		brne		Test_Timer_Execute_B
		lds		publik1,Flag_A_On		;    
		lds		publik2,Flag_A_Off
		sts		Flag_A_On,publik3
		sts		Flag_A_Off,publik3
		
		sts	Flag_New_Symbol_A,temp3
Test_Timer_Execute_B:		
		lds		xl,Timer_Execute_B
		lds		xh,Timer_Execute_B+1
		sbiw		xl,1
		or		xl,xh
		brne		Flag_Analiz
		lds		publik3,Flag_B_On		;    
		lds		publik4,Flag_B_Off
		sts		Flag_B_On,xh			;     
		sts		Flag_B_Off,xh
		sts	Flag_New_Symbol_B,temp3
Flag_Analiz:
		ldi		temp1,high(Mode_A) ;       A
		out		EEARH,temp1
		ldi		temp1,low(Mode_A)
		out		EEARL,temp1
		sbi		EECR,EERE

		sbis	EEDR,7
		clr	publik1
		sbis	EEDR,7
		clr	publik2

		ldi		temp2,high(Mode_B) ;       B
		out		EEARH,temp2
		ldi		temp2,low(Mode_B)
		out		EEARL,temp2
		sbi		EECR,EERE

		sbis	EEDR,7
		clr	publik3
		sbis	EEDR,7
		clr	publik4

		or		publik1,publik4
		or		publik2,publik3		; publik1=A_On, publik2=A_off

		ldi		temp2,high(Flag_Prioritet) ;   
		out		EEARH,temp2
		ldi		temp2,low(Flag_Prioritet)
		out		EEARL,temp2
		sbi		EECR,EERE
		in		temp2,EEDR
		
		mov		publik3,publik1
		or		publik3,publik2
		breq	Test_Relay_Sygnal		;----->    A_On  A_Off
		mov		temp1,publik1
		eor		temp1,publik2
		brne		Do_Not_Conflikt
		and		publik2,temp2
Do_Not_Conflikt:
		tst		publik2
		breq	Set_Relay_0
		sbi		PORTD,Control_Relay
		sbi		PORTD,Control_Relay_1
		rjmp	Test_Relay_Sygnal
;		lds	xl,TestCounter
;		lds	xh,TestCounter+1
;		adiw	xl,1
;		sts	TestCounter,xl
;		sts	TestCounter+1,xh
Set_Relay_0:		
		cbi	PORTD,Control_Relay
		cbi	PORTD,Control_Relay_1
		ldi	temp1,low(Relay_Time)
		ldi	temp2,high(Relay_Time)
		sts	Timer_Relay,temp1
		sts	Timer_Relay+1,temp2
		
;        
Test_Relay_Sygnal:
		ser	temp3
		lds	temp1,Timer_Relay
		lds	temp2,Timer_Relay+1
		or	temp1,temp2
		brne	Test_Control_Sygnal
		sbi	PORTD,Control_Relay_1
Test_Control_Sygnal:
		lds		temp1,Timer_Control
		lds		temp2,Timer_Control+1
		or		temp1,temp2
		brne	Test_Key		;--->
		ldi	yh,high(Period_Control)
		ldi	yl,low(Period_Control)
		lds	xl,Counter_TimeCorrect
		lds	xh,Counter_TimeCorrect+1
		sbiw	xl,1
		brne	Timer_Correct		;--->
		ldi	xl,low(Period_TimeCorrect)
		ldi	xh,high(Period_TimeCorrect)
		ldi	yh,high(Period_ControlCorrect)
		ldi	yl,low(Period_ControlCorrect)
Timer_Correct:
		sts	Counter_TimeCorrect,xl
		sts	Counter_TimeCorrect+1,xh

		sts		Timer_Control,yl
		sts		Timer_Control+1,yh
Clock:
		sts	Flag_Clock,temp3
		lds	temp1,Clock_Sec
		inc	temp1
		sts	Clock_Sec,temp1
		cpi	temp1,60
		brcs	Clock_1
		sts	Clock_Sec,zero
		
		lds	temp1,Clock_Min
		inc	temp1
		sts	Clock_Min,temp1
		cpi	temp1,60
		brcs	Clock_1
		sts	Clock_Min,zero
		
		lds	temp1,Clock_Hour
		inc	temp1
		sts	Clock_Hour,temp1
		cpi	temp1,24
		brcs	Clock_1
		sts	Clock_Hour,zero
Clock_1:
Test_Key:
		mov	temp1,New_Port_A
		mov	temp2,New_Port_C
		andi	temp1,0xc0
		andi	temp2,0xc0
		swap	temp1
		swap	temp2
		lsr	temp1
		lsr	temp1
		or	temp1,temp2	;  temp1- 
		cp	Old_Key,temp1
		mov	Old_Key,temp1
		breq	Test_Key_1	;  
		ldi	temp2,Drebezg
		sts	Timer_Drebezg,temp2 ;    
		ldi	temp2,low(PushButton)
		ldi	temp3,high(PushButton)
		cpi	temp1,0x0f
		brne	Test_Key_5
		ldi	temp2,low(Display_Time)
		ldi	temp3,high(Display_Time)
Test_Key_5:
		sts	Timer_PushButton,temp2 ;    
		sts	Timer_PushButton+1,temp3
		ldi	temp2,low(Repeat)
		sts	Counter_Repeat,temp2 ;    
		ldi	temp2,high(Repeat)
		sts	Counter_Repeat+1,temp2
Test_Key_1:
		lds	temp2,Timer_Drebezg
		tst	temp2
		brne	Test_Key_3	;---->   -   
		tst	Flag_NewKey
		brne	Test_Key_3	;--->     
		lds	temp2,Key
		eor	temp2,temp1
		brne	Test_Key_2	;--->    
		lds	temp3,Timer_PushButton
		lds	temp2,Timer_PushButton+1
		or	temp3,temp2
		brne	Test_Key_3	;--->     
		
		cpi	temp1,0x0f
		breq	Light_Off
		
		lds	temp2,Flag_AutoRepeat
		or	temp2,temp1
		cp	temp2,temp1
		brne	Test_Key_3
		
		lds	xl,Counter_Repeat
		sts	Timer_PushButton,xl ;    
		lds	xh,Counter_Repeat+1
		sts	Timer_PushButton+1,xh
		sbiw	xl,Repeat_Step
		mov	temp2,xl
		or	temp2,xh
		brne	Test_Key_4
		adiw	xl,Repeat_Step
Test_Key_4:	
		sts	Counter_Repeat,xl
		sts	Counter_Repeat+1,xh
Test_Key_2:
		sts	Key,Old_Key
		cpi	temp1,0x0f
		breq	Test_Key_3
		ser	Flag_NewKey
;- 
		cbi	PORTD,LCD_Light
Test_Key_3:
	
Restore_Data:
		mov		Old_Port_A,New_Port_A
		mov		Old_Port_C,New_Port_C
;  
		pop		zh
		pop		zl
		pop		yh
		pop		yl
		pop		xh
		pop		xl
		pop		temp6
;		pop		temp5
		pop		temp4
		pop		temp3
		pop		temp2
		pop		temp1
		out		SREG,Status_Copy
		reti
Light_Off:
		sbi	PORTD,LCD_Light
		rjmp	Restore_Data
;==========================
;   
Test_Sequence:
		ldi		counter,Number_Sequence/2
		clt
Test_Sequence_1:
		adiw	yl,Position_Flag_On
		
		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
;		in		publik2,EEDR

		sbiw	yl,Position_Flag_On
;		rol		publik2

		ld		temp1,x+
		ld		publik2,x+	;  pause(n) x     
		sbis	EEDR,7
		rjmp	Next_Test_Sequence
;		brcc	Test_Sequence_5
;;		brcc	Next_Test_Sequence	; ----->       
		mov		publik3,zl
		mov		publik4,zh
		mov		zl,Index_L
		mov		zh,Index_H
		
		or		temp1,publik2
;		brne	Next_Test_Sequence	; -->            
		brne	Next_Test_Sequence_Z0
;   
	
;--     
		
		brts	Test_Sequence_3
		
		clr		publik5
		clr		publik6
		clr		temp3
		clr		temp4
;--     
Test_Sequence_3:
;		mov		publik3,zl
;		mov		publik4,zh
;		mov		zl,Index_L
;		mov		zh,Index_H
		ld		temp1,z		; temp1= (n)
		add		yl,temp1
		adc		yh,zero

		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
		in		temp2,EEDR	;      

		sub		yl,temp1
		sbc		yh,zero
		eor		temp2,publik7
;		andi	temp2,0x0f
		breq	Next_Test_1	;------->	 
;   ,   

		sbrc	temp6,2
		rjmp	Next_Test_11
Test_Sequence_4:
		rjmp	Next_Test_Sequence_Z0	;------>
;--------
Test_Sequence_2:
		mov	publik5,temp1
Next_Test_Sequence_Z0:
		st		z,zero	;   
Next_Test_Sequence_Z:
		mov		zl,publik3
		mov		zh,publik4
Next_Test_Sequence:
		adiw	yl,Wide_Table
		adiw	zl,2
		ldi		temp2,1
		add		Index_L,temp2
		adc		Index_H,zero
		dec		counter
		brne	Test_Sequence_1
		ret
Next_Test_11:
		ldi	temp1,Wide_Table-2
Next_Test_1:
;		cpi	temp1,Max_SeqSymbol
;		brcc	Next_Test_12
		inc		temp1		;  ,   
Next_Test_12:
		st		z,temp1		;   temp1  , temp2=0
;   
		adiw	yl,Position_DTMF_Length ;    

		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
		in		publik1,EEDR

		adiw	yl,1

		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
		in		publik2,EEDR

;		sbiw	yl,Position_DTMF_Length+1
		mov		zl,publik3
		mov		zh,publik4

;  
		adiw	yl,Position_Pause_Length-Position_DTMF_Length-1	;   

		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
		in		publik3,EEDR

		adiw	yl,1

		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
		in		publik4,EEDR

;		sbiw	yl,Position_Pause_Length+1
;    
		add	publik1,publik1
		adc	publik2,publik2
		add	publik1,publik3
		adc	publik2,publik4
		
		st		z+,publik1
		st		z+,publik2
		sbiw	zl,2		
;   
;		st		-x,publik4
;		st		-x,publik3
;		adiw	xl,2			; x    

;     
		adiw	yl,Position_Number_Symbol-Position_Pause_Length-1

		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
		in		publik2,EEDR

		sbiw	yl,Position_Number_Symbol
;       
		eor		temp1,publik2
;       
		brne	Next_Test_Sequence		; ------>
;  
;---------    
		adiw	yl,Position_Timer_Wait

		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
;		in		publik1,EEDR
		in		temp3,EEDR
		adiw	yl,1

		out		EEARH,yh
		out		EEARL,yl
		sbi		EECR,EERE
;		in		publik2,EEDR
		in		temp4,EEDR
		
		sbiw	yl,Position_Timer_Wait+1

;		adiw	yl,Position_DTMF_Length

;		out		EEARH,yh
;		out		EEARL,yl
;		sbi		EECR,EERE
;		in		temp3,EEDR
		
;		adiw	yl,1

;		out		EEARH,yh
;		out		EEARL,yl
;		sbi		EECR,EERE
;		in		temp4,EEDR
		
;		sbiw	yl,Position_DTMF_Length+1
;;		ldi		temp3,1			;  
;;		clr		temp4
		set
;  0-off, 81h-*, 82h-
;		sbrc	temp6,0
;		rjmp	Next_Test_2	;---->      *
; 
;		adiw	yl,Position_Timer_Wait

;		out		EEARH,yh
;		out		EEARL,yl
;		sbi		EECR,EERE
;;		in		publik1,EEDR
;		in		temp3,EEDR
;		adiw	yl,1

;		out		EEARH,yh
;		out		EEARL,yl
;		sbi		EECR,EERE
;;		in		publik2,EEDR
;		in		temp4,EEDR
		
;		sbiw	yl,Position_Timer_Wait+1
		
;;		mov		temp3,publik1
;;		mov		temp4,publik2
; --------     (    )
Next_Test_2:
		mov	publik3,zl
		mov	publik4,zh
		mov	zl,Index_L
		mov	zh,Index_H

;      On (81)  Off(82)
		adiw	yl,Position_Flag_On
		
		out	EEARH,yh
		out	EEARL,yl
		sbi	EECR,EERE
;		in	temp2,EEDR

		sbiw	yl,Position_Flag_On
		ser	temp1
;		sbrc	temp2,0		; temp2=81  On
		sbic	EEDR,0
		rjmp	Test_Sequence_2	;   ON
		mov	publik6,temp1	;  Off
		rjmp	Next_Test_Sequence_Z0
;========================================
Main:
		rcall	LCD_Init
		rcall	Write_Character
		rjmp	Edit_1
;-   
Edit_Clock:
		ldi	temp1,AutoKey_1i3
		sts	Flag_AutoRepeat,temp1
		lds	temp1,Flag_New_Symbol_A
		lds	temp2,Flag_New_Symbol_B
		or	temp1,temp2
		brne	Edit_1_FromClock
		
		lds	temp1,Flag_Clock
		tst	temp1
		breq	Edit_Clock_1
		sts	Flag_Clock,zero
		ldi	temp1,11
		rcall	Copy_Screen
		ldi	temp1,0
		rcall	Print_Time
		rcall	Menu_1_ForClock
		rcall	Ram_To_LCD
Edit_Clock_1:
		tst	Flag_NewKey
		breq	Edit_Clock_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp1,Key_1
		breq	Edit_1
		cpi	temp1,Key_2
		brne	Edit_Key_1
		rjmp	Edit_12
Edit_Key_1:
		cpi	temp1,Key_4
		brne	Edit_Key_2
		rjmp	Edit_2
Edit_Key_2:		
		cpi	temp1,Key_3
		brne	Edit_Clock_NoKey
		rjmp	Edit_3
Edit_Clock_NoKey:
		sleep
		rjmp	Edit_Clock
;-----
Edit_1_Test_Key_1:
		rcall	Edit_4
Edit_1:
		clr	Flag_NewKey
		rcall	Menu_1
		rcall	RAM_To_LCD
Edit_1_Test_Key:
		ldi	temp1,AutoKey_No
		sts	Flag_AutoRepeat,temp1
		
		sbic	PORTD,LCD_Light
		rjmp	Edit_Clock
	
		lds	temp1,Flag_New_Symbol_A
		lds	temp2,Flag_New_Symbol_B
		or	temp1,temp2
		breq	Edit_1_InTest_6
Edit_1_FromClock:
		ldi	temp1,low(Display_Time)
		sts	Timer_PushButton,temp1 ;    
		ldi	temp1,high(Display_Time)
		sts	Timer_PushButton+1,temp1		
		cbi	PORTD,LCD_Light

		rcall	Menu_1
		
		lds	temp1,Flag_New_Symbol_A
		tst	temp1
		breq	Edit_1_InTest_4
		sts	Flag_New_Symbol_A,zero
		mov	temp1,Old_Port_A
		andi	temp1,0x0f
		ldi	zl,low(2*StringN)
		ldi	zh,high(2*StringN)
		add	zl,temp1
		adc	zh,zero
		add	zl,temp1
		adc	zh,zero
		ldi	temp1,18
		rcall	Print_String
Edit_1_InTest_4:
		lds	temp1,Flag_New_Symbol_B
		tst	temp1
		breq	Edit_1_InTest_5
		sts	Flag_New_Symbol_B,zero
		mov	temp1,Old_Port_C
		andi	temp1,0x0f
		ldi	zl,low(2*StringN)
		ldi	zh,high(2*StringN)
		add	zl,temp1
		adc	zh,zero
		add	zl,temp1
		adc	zh,zero
		ldi	temp1,18+24
		rcall	Print_String
Edit_1_InTest_5:
		rcall	RAM_To_LCD
Edit_1_InTest_6:
		tst	Flag_NewKey
		breq	Edit_1_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		clr	edited_ch
		cpi	temp1,Key_1
Edit_1_Test_Key_2:
		breq	Edit_1_Test_Key_1
		com	edited_ch
		cpi	temp1,Key_2
		breq	Edit_1_Test_Key_2
		cpi	temp1,Key_3
		breq	Edit_3
		cpi	temp1,Key_4
		breq	Edit_2
		cpi	temp1,Key_1i2
		brne	Edit_1_NoKey
		rjmp	Edit_13
Edit_1_NoKey:
		sleep
		rjmp	Edit_1_Test_Key
;---
Edit_2_Test_Key_1:
		rcall	Edit_4
Edit_2:
		ldi	temp1,AutoKey_No
		sts	Flag_AutoRepeat,temp1
		sbi		PORTD,Control_Relay
		sbi		PORTD,Control_Relay_1

;		clr	Flag_NewKey
		ldi	temp1,2		; 2-
		rcall	Copy_Screen
		rcall	RAM_To_LCD
Edit_2_Test_Key:
		sts	Timer_Valid_A,zero
		sts	Timer_Valid_B,zero
		tst	Flag_NewKey
		breq	Edit_2_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		clr	edited_ch
		cpi	temp1,Key_1
		breq	Edit_2_Test_Key_1
		com	edited_ch
		cpi	temp1,Key_2
		breq	Edit_2_Test_Key_1
		cpi	temp1,Key_3
		breq	Edit_3
		cpi	temp1,Key_4
		brne	Edit_2_NoKey
		rjmp	Edit_1
Edit_2_NoKey:
		sleep
		rjmp	Edit_2_Test_Key
;---
Edit_3_Test_Key_1:
		rcall	Edit_4
Edit_3:
		ldi	temp1,AutoKey_No
		sts	Flag_AutoRepeat,temp1
		cbi		PORTD,Control_Relay
		cbi		PORTD,Control_Relay_1
		ldi	temp1,low(Relay_Time)
		ldi	temp2,high(Relay_Time)
		sts	Timer_Relay,temp1
		sts	Timer_Relay+1,temp2
		
;		clr	Flag_NewKey
		ldi	temp1,3		; 3-
		rcall	Copy_Screen
		rcall	RAM_To_LCD
Edit_3_Test_Key:
		sts	Timer_Valid_A,zero
		sts	Timer_Valid_B,zero
		tst	Flag_NewKey
		breq	Edit_3_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		clr	edited_ch
		cpi	temp1,Key_1
		breq	Edit_3_Test_Key_1
		com	edited_ch
		cpi	temp1,Key_2
		breq	Edit_3_Test_Key_1
		cpi	temp1,Key_4
		breq	Edit_2
		cpi	temp1,Key_3
		brne	Edit_3_NoKey
		rjmp	Edit_1
Edit_3_NoKey:
		sleep
		rjmp	Edit_3_Test_Key
;---
Edit_10:
		ldi	temp1,AutoKey_No
		sts	Flag_AutoRepeat,temp1
;		clr	Flag_NewKey
		rcall	Menu_10
		rcall	RAM_To_LCD
Edit_10_Test_Key:
		tst	Flag_NewKey
		breq	Edit_10_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp1,Key_2
		breq	Edit_10_Select	;  
		cpi	temp1,Key_3
		breq	Edit_10_OK
		cpi	temp1,Key_4
		brne	Edit_10_NoKey
		rjmp	Edit_9
Edit_10_NoKey:
		sleep
		rjmp	Edit_10_Test_Key
Edit_10_Select:
		lds	temp1,Sequence_Copy+Position_Flag_On
		inc	temp1
		cpi	temp1,0x83
		brne	Edit_10_Select_1
		clr	temp1
Edit_10_Select_1:
		cpse	temp1,zero
		ori	temp1,0x80
		sts	Sequence_Copy+Position_Flag_On,temp1
		rjmp	Edit_10
Edit_10_OK:
		rcall	Calculate_Parameter
		rcall	Write_Sequence_ToEEPROM
;		rjmp	Edit_4
;---
Edit_4:
		ldi	temp1,AutoKey_No
		sts	Flag_AutoRepeat,temp1
		ldi	yl,low(Mode_A)
		ldi	yh,high(Mode_A)
		rcall	Read_EEPROM
		sts	Mode_A_Copy,temp1
		ldi	yl,low(Mode_B)
		ldi	yh,high(Mode_B)
		rcall	Read_EEPROM
		sts	Mode_B_Copy,temp1
Edit_4_1:	
;		clr	Flag_NewKey
		rcall	Menu_4
		rcall	RAM_To_LCD
Edit_4_Test_Key:
		sbic	PORTD,LCD_Light
		ret
		
		tst	Flag_NewKey
		breq	Edit_4_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp1,Key_2
		breq	Edit_4_Mode	;  
		cpi	temp1,Key_3
		breq	Edit_4_Next
		cpi	temp1,Key_4
		breq	Edit_4_WriteMode
Edit_4_NoKey:
		sleep
		rjmp	Edit_4_Test_Key
Edit_4_Mode:
		ldi	xl,low(Mode_A_Copy)
		ldi	xh,high(Mode_A_Copy)
		cpse	edited_ch,zero
		adiw	xl,Mode_B_Copy-Mode_A_Copy
Edit_4_Mode_1:
		ld	temp1,x
		inc	temp1
		cpi	temp1,0x83
		brne	Edit_4_Mode_2
		ldi	temp1,0x85
Edit_4_Mode_2:
		cpi	temp1,0x87
		brne	Edit_4_Mode_3
		clr	temp1
Edit_4_Mode_3:
		cpse	temp1,zero
		ori	temp1,0x80
		st	x,temp1
		rjmp	Edit_4_1
;-
Edit_4_WriteMode:
		ldi	yl,low(Mode_A)
		ldi	yh,high(Mode_A)
		ldi	xl,low(Mode_A_Copy)
		ldi	xh,high(Mode_A_Copy)
		tst	edited_ch
		breq	Edit_4_WriteMode_1
		adiw	yl,Mode_B-Mode_A
		adiw	xl,Mode_B_Copy-Mode_A_Copy
Edit_4_WriteMode_1:
		ld	temp1,x
		rcall	Write_EEPROM
		ret
Edit_4_Next:
		rcall	Edit_4_WriteMode
;		rjmp	Edit_5
;---
Edit_5:
		ldi	temp1,AutoKey_No
		sts	Flag_AutoRepeat,temp1
		ldi	temp2,1		;  
Edit_5_NoChangeNumber:
;		clr	Flag_NewKey
		rcall	Copy_To_RAM
		rcall	Menu_5
		rcall	RAM_To_LCD
Edit_5_Test_Key:
		tst	Flag_NewKey
		breq	Edit_5_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp1,Key_1
		breq	Edit_5_Up	;   
		cpi	temp1,Key_2
		breq	Edit_5_Down	;   
		cpi	temp1,Key_3
		breq	Edit_6
		cpi	temp1,Key_4
		brne	Edit_5_NoKey
		rcall	Calculate_Parameter
		rjmp	Edit_4
Edit_5_NoKey:
		sleep
		rjmp	Edit_5_Test_Key
Edit_5_Up:
		inc	temp2
		cpi	temp2,9
		brne	Edit_5_NoChangeNumber
		rjmp	Edit_5
Edit_5_Down:
		dec	temp2
		tst	temp2
		brne	Edit_5_NoChangeNumber
		ldi	temp2,8
		rjmp	Edit_5_NoChangeNumber
;---
Edit_6:
		ldi	temp1,AutoKey_No	;1i2
		sts	Flag_AutoRepeat,temp1
		ldi	xl,low(Sequence_Copy)
		ldi	xh,high(Sequence_Copy)
		ldi	temp3,1		;   
		ldi	temp1,0x0e	;  
		rcall	Command_To_LCD
		lds	temp4,Sequence_Copy+Position_Number_Symbol
Edit_6_NoChange:
;		clr	Flag_NewKey
		rcall	Menu_6
Edit_6_1:
		lds	temp1,Sequence_Copy+Position_Number_Symbol
		cp	temp1,temp3
		brcc	Edit_6_3
Edit_6_2:
		tst	temp1
		brne	Edit_6_4
		inc	temp1
		sts	Sequence_Copy+Position_Number_Symbol,temp1
		ldi	zl,low(2*String16Space)
		ldi	zh,high(2*String16Space)
		ldi	temp1,2+24
		rcall	Print_String
Edit_6_4:
		ldi	temp1,17
		st	x,temp1
Edit_6_5:		
		ldi	zl,low((StringN+17)*2)
		ldi	zh,high((StringN+17)*2)
		ldi	temp1,2+24-1
		add	temp1,temp3
		rcall	Print_String
Edit_6_3:
		rcall	RAM_To_LCD
		ldi	temp1,0xc0+1
		add	temp1,temp3
		rcall	Command_To_LCD
Edit_6_Test_Key:
		tst	Flag_NewKey
		breq	Edit_6_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp3,Max_SeqSymbol+1
		breq	Edit_6_Test_Key_1
		cpi	temp1,Key_1
		breq	Edit_6_Up	;   
		cpi	temp1,Key_2
		brne	Edit_6_Test_Key_1
		rjmp	Edit_6_Down	;   
Edit_6_Test_Key_1:		
		cpi	temp1,Key_3
		breq	Edit_6_Next	;      7  8
		cpi	temp1,Key_4
		breq	Edit_6_Ret
Edit_6_NoKey:
		sleep
		rjmp	Edit_6_Test_Key
Edit_6_Ret:
;		rcall	Calculate_Parameter
		rjmp	Edit_5_NoChangeNumber
Edit_6_Next:
		cpi	temp3,Max_SeqSymbol+1
		breq	Edit_6_Next_2
		ld	temp1,x
		cpi	temp1,17
		brne	Edit_6_Next_3
		cpi	temp3,1
		breq	Edit_6_Next_5
Edit_6_Next_2:
		rcall	Check_Sequence
		cpse	temp5,zero	;  temp5   
		rjmp	Edit_7
;		rcall	Calculate_Parameter
		rcall	Write_Sequence_ToEEPROM
		rjmp	Edit_8
Edit_6_Next_5:
		sts	Sequence_Copy+Position_Number_symbol,zero
;		rjmp	Edit_8
		sts	Sequence_Copy+Position_Flag_On,zero
		rcall	Write_Sequence_ToEEPROM
		rjmp	Edit_5_NoChangeNumber
Edit_6_Next_3:
		lds	temp1,Sequence_Copy+Position_Number_symbol
		cp	temp1,temp3
		brcc	Edit_6_Next_4
		sts	Sequence_Copy+Position_Number_symbol,temp3
Edit_6_Next_4:
		inc	temp3
		adiw	xl,1
		cpi	temp3,Max_SeqSymbol+1
		breq	Edit_6_5
		rjmp	Edit_6_1
Edit_6_Up:
		ld	temp1,x
		inc	temp1
		cpi	temp1,16
		brne	Edit_6_Up_1
		ldi	temp1,17
Edit_6_Up_1:
		cpi	temp1,18
		brne	Edit_6_Up_2
		ldi	temp1,0
Edit_6_Up_2:
		rjmp	Edit_6_Down_3
Edit_6_Down:
		ld	temp1,x
		dec	temp1
Edit_6_Down_1:
		cpi	temp1,16
		brne	Edit_6_Down_2
		ldi	temp1,15
Edit_6_Down_2:
		cpi	temp1,-1
		brne	Edit_6_Down_3
		ldi	temp1,17
Edit_6_Down_3:
		st	x,temp1
		
		cpi	temp1,17
		mov	temp1,temp3
		breq	Edit_6_Down_5
		cp	temp3,temp4
		brcc	Edit_6_Down_4
		mov	temp1,temp4
Edit_6_Down_4:		
		sts	Sequence_Copy+Position_Number_symbol,temp1
		rjmp	Edit_6_NoChange
Edit_6_Down_5:
		dec	temp1
		sts	Sequence_Copy+Position_Number_symbol,temp1
		rjmp	Edit_6_NoChange	
;---
Edit_7:
		ldi	temp1,AutoKey_No
		sts	Flag_AutoRepeat,temp1
		ldi	temp1,0x0c	;  
		rcall	Command_To_LCD
;		clr	Flag_NewKey
		rcall	Menu_7
		rcall	RAM_To_LCD
Edit_7_Test_Key:
		tst	Flag_NewKey
		breq	Edit_7_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp1,Key_3
		brne	Edit_7_NoKey
		rjmp	Edit_6
Edit_7_NoKey:
		sleep
		rjmp	Edit_7_Test_Key
;---
Edit_8:
		ldi	temp1,AutoKey_1i2
		sts	Flag_AutoRepeat,temp1
		ldi	temp1,0x0c	;  
		rcall	Command_To_LCD
;		clr	Flag_NewKey

		ldi	yh,high(Time_DTMF_valid_A)
		ldi	yl,low(Time_DTMF_valid_A)
		cpse	edited_ch,zero
		adiw	yl,Time_DTMF_valid_B-Time_DTMF_valid_A
Edit_8_1:
		rcall	Read_EEPROM
		mov	xl,temp1
		clr	xh
		
		ldi	yh,high(Time_DTMF_NOvalid_A)
		ldi	yl,low(Time_DTMF_NOvalid_A)
		cpse	edited_ch,zero
		adiw	yl,Time_DTMF_NOvalid_B-Time_DTMF_NOvalid_A
Edit_8_2:
		rcall	Read_EEPROM
		add	xl,temp1
		adiw	xl,12
		
		ldi	temp1,low(MinSymbolTime)
		ldi	temp3,high(MinSymbolTime)
		sub	temp1,xl
		sbc	temp3,xh
		brcs	Edit_8_3
		ldi	xl,low(MinSymbolTime)
		ldi	xh,high(MinSymbolTime)
Edit_8_3:
		sts	MinTime_Tone,xl
		sts	MinTime_Tone+1,xh

		rcall	Menu_8
		rcall	RAM_To_LCD
Edit_8_Test_Key:
		tst	Flag_NewKey
		breq	Edit_8_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp1,Key_1
		breq	Edit_8_Up	;   
		cpi	temp1,Key_2
		breq	Edit_8_Down	;   
		cpi	temp1,Key_3
		breq	Edit_8_OK
		cpi	temp1,Key_4
		brne	Edit_8_NoKey
		rjmp	Edit_6
Edit_8_NoKey:
		sleep
		rjmp	Edit_8_Test_Key
Edit_8_Up:
		lds	xl,Sequence_Copy+Position_DTMF_Length
		lds	xh,Sequence_Copy+Position_DTMF_Length+1
		adiw	xl,1
		cpi	xh,high(MaxTime)
		brne	Edit_8_Down_1
		cpi	xl,low(MaxTime)
		brne	Edit_8_Down_1
		ldi	xl,low(MaxTime-1)
		ldi	xh,high(MaxTime-1)
		rjmp	Edit_8_Down_1
Edit_8_Down:
		lds	xl,Sequence_Copy+Position_DTMF_Length
		lds	xh,Sequence_Copy+Position_DTMF_Length+1
		sbiw	xl,1
		lds	temp1,MinTime_Tone
		sub	temp1,xl
		lds	temp1,MinTime_Tone+1
		sbc	temp1,xh
		brcs	Edit_8_Down_1
		lds	xl,MinTime_Tone
		lds	xh,MinTime_Tone+1
Edit_8_Down_1:
		sts	Sequence_Copy+Position_DTMF_Length,xl
		sts	Sequence_Copy+Position_DTMF_Length+1,xh
		rjmp	Edit_8
Edit_8_OK:
;		rcall	Calculate_PSL
		rcall	Write_Sequence_ToEEPROM
;		rjmp	Edit_9
;---
Edit_9:
		ldi	temp1,AutoKey_1i2
		sts	Flag_AutoRepeat,temp1
;		clr	Flag_NewKey
		rcall	Menu_9
		rcall	RAM_To_LCD
		
Edit_9_Test_Key:
		tst	Flag_NewKey
		breq	Edit_9_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp1,Key_4
		brne	Edit_9_Test_Key_1
		rjmp	Edit_8
Edit_9_Test_Key_1:
		cpi	temp1,Key_1
		breq	Edit_9_Up	;   
		cpi	temp1,Key_2
		breq	Edit_9_Down	;   
		cpi	temp1,Key_3
		brne	Edit_9_NoKey
		rjmp	Edit_9_OK
Edit_9_NoKey:
		sleep
		rjmp	Edit_9_Test_Key
Edit_9_Up:
		lds	xl,Sequence_Copy+Position_Pause_Length
		lds	xh,Sequence_Copy+Position_Pause_Length+1
		adiw	xl,1
		cpi	xh,high(MaxTime)
		brne	Edit_9_Down_1
		cpi	xl,low(MaxTime)
		brne	Edit_9_Down_1
		sbiw	xl,1
		rjmp	Edit_9_Down_1
Edit_9_Down:
		lds	xl,Sequence_Copy+Position_Pause_Length
		lds	xh,Sequence_Copy+Position_Pause_Length+1
		sbiw	xl,1
		cpi	xh,high(-1)
		brne	Edit_9_Down_1
		cpi	xl,low(-1)
		brne	Edit_9_Down_1
		adiw	xl,1
Edit_9_Down_1:
		sts	Sequence_Copy+Position_Pause_Length,xl
		sts	Sequence_Copy+Position_Pause_Length+1,xh
		rjmp	Edit_9
Edit_9_OK:
		rcall	Write_Sequence_ToEEPROM
		rjmp	Edit_10
;-- 
Edit_12:
		ldi	temp1,AutoKey_1i3
		sts	Flag_AutoRepeat,temp1
;		clr	Flag_NewKey
		
		lds	temp1,Clock_Min
		sts	Clock_Min_Copy,temp1
		lds	temp1,Clock_Hour
		sts	Clock_Hour_Copy,temp1
		
		ldi	temp1,12
		rcall	Copy_Screen
Edit_12_Ref:
		ldi	temp1,8
		ldi	yl,low(Clock_Hour_Copy)
		ldi	yh,high(Clock_Hour_Copy)
		rcall	Print_2Number
		ldi	yl,low(Clock_Min_Copy)
		ldi	yh,high(Clock_Min_Copy)
		ldi	temp1,11
		rcall	Print_2Number
		
;		ldi	yl,low(TestCounter)
;		ldi	yh,high(TestCounter)
;		ldi	temp1,7+24
;		rcall	Print_3Number
		
		rcall	RAM_To_LCD
Edit_12_Test_Key:
		sbic	PORTD,LCD_Light
		rjmp	Edit_Clock

		tst	Flag_NewKey
		breq	Edit_12_NoKey
		
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp1,Key_1
		breq	Edit_12_Hour
		cpi	temp1,Key_2
		breq	Edit_12_Ret
		cpi	temp1,Key_3
		breq	Edit_12_Min
		cpi	temp1,Key_4
		breq	Edit_12_Ok
Edit_12_NoKey:
		sleep
		rjmp	Edit_12_Test_Key
Edit_12_Hour:
		lds	temp1,Clock_Hour_Copy
		inc	temp1
		cpi	temp1,24
		brne	Edit_12_Hour_1
		clr	temp1
Edit_12_Hour_1:
		sts	Clock_Hour_Copy,temp1
		rjmp	Edit_12_Ref
Edit_12_Min:
		lds	temp1,Clock_Min_Copy
		inc	temp1
		cpi	temp1,60
		brne	Edit_12_Min_1
		clr	temp1
Edit_12_Min_1:
		sts	Clock_Min_Copy,temp1
		rjmp	Edit_12_Ref
Edit_12_Ok:
		lds	temp1,Clock_Min_Copy
		sts	Clock_Min,temp1
		lds	temp1,Clock_Hour_Copy
		sts	Clock_Hour,temp1
		sts	Clock_Sec,zero
		ldi	temp1,low(Period_Control)
		sts	Timer_Control,zero
		ldi	temp1,high(Period_Control)
		sts	Timer_Control+1,temp1
Edit_12_Ret:
		rjmp	Edit_Clock
;-- Valid
Edit_13:
		ldi	temp1,AutoKey_1i2
		sts	Flag_AutoRepeat,temp1
		ldi	yl,low(Time_DTMF_valid_A)
		ldi	yh,high(Time_DTMF_valid_A)
		rcall	Read_EEPROM
		dec	temp1
		sts	Time_Valid_A_Copy,temp1
		sts	Time_Valid_A_Copy+1,zero
		ldi	yl,low(Time_DTMF_valid_B)
		ldi	yh,high(Time_DTMF_valid_B)
		rcall	Read_EEPROM
		dec	temp1
		sts	Time_Valid_B_Copy,temp1
		sts	Time_Valid_B_Copy+1,zero
;		clr	Flag_NewKey
Edit_13_1:
		rcall	Menu_13
		rcall	RAM_To_LCD
Edit_13_Test_Key:
		sbic	PORTD,LCD_Light
		rjmp	Edit_Clock
		
		tst	Flag_NewKey
		breq	Edit_13_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp1,Key_1
		breq	Edit_13_A
		cpi	temp1,Key_2
		breq	Edit_13_B
		cpi	temp1,Key_3
		breq	Edit_13_OK
		cpi	temp1,Key_4
		brne	Edit_13_NoKey
		rjmp	Edit_1
Edit_13_NoKey:
		sleep
		rjmp	Edit_13_Test_Key
Edit_13_A:
		lds	temp1,Time_Valid_A_Copy
		inc	temp1
		cpi	temp1,100
		brne	Edit_13_A_1
		ldi	temp1,MinPauseTime
Edit_13_A_1:
		sts	Time_Valid_A_Copy,temp1
		rjmp	Edit_13_1
Edit_13_B:
		lds	temp1,Time_Valid_B_Copy
		inc	temp1
		cpi	temp1,100
		brne	Edit_13_B_1
		ldi	temp1,MinPauseTime
Edit_13_B_1:
		sts	Time_Valid_B_Copy,temp1
		rjmp	Edit_13_1
Edit_13_OK:
		lds	temp1,Time_Valid_A_Copy
		inc	temp1
		mov	temp2,temp1
		ldi	yl,low(Time_DTMF_valid_A)
		ldi	yh,high(Time_DTMF_valid_A)
		rcall	Write_EEPROM
		
		ldi	yl,low(Time_DTMF_NOvalid_A)
		ldi	yh,high(Time_DTMF_NOvalid_A)
		rcall	Read_EEPROM
;		subi	temp2,5
		cp	temp1,temp2
		brcs	Edit_13_OK_1
		mov	temp1,temp2
Edit_13_OK_1:
		rcall	Write_EEPROM
		
		lds	temp1,Time_Valid_B_Copy
		inc	temp1
		mov	temp2,temp1
		ldi	yl,low(Time_DTMF_valid_B)
		ldi	yh,high(Time_DTMF_valid_B)
		rcall	Write_EEPROM
		
		ldi	yl,low(Time_DTMF_NOvalid_B)
		ldi	yh,high(Time_DTMF_NOvalid_B)
		rcall	Read_EEPROM
;		subi	temp2,5
		cp	temp1,temp2
		brcs	Edit_13_OK_2
		mov	temp1,temp2
Edit_13_OK_2:
		rcall	Write_EEPROM
;-- NoValid
Edit_14:
		ldi	temp1,AutoKey_1i2
		sts	Flag_AutoRepeat,temp1
		ldi	yl,low(Time_DTMF_NOvalid_A)
		ldi	yh,high(Time_DTMF_NOvalid_A)
		rcall	Read_EEPROM
		dec	temp1
		sts	Time_NoValid_A_Copy,temp1
		ldi	yl,low(Time_DTMF_NOvalid_B)
		ldi	yh,high(Time_DTMF_NOvalid_B)
		rcall	Read_EEPROM
		dec	temp1
		sts	Time_NoValid_B_Copy,temp1

;		clr	Flag_NewKey
Edit_14_1:
		rcall	Menu_14
		rcall	RAM_To_LCD
Edit_14_Test_Key:
		sbic	PORTD,LCD_Light
		rjmp	Edit_Clock
		
		tst	Flag_NewKey
		breq	Edit_14_NoKey
		clr	Flag_NewKey
		lds	temp1,Key
		cpi	temp1,Key_1
		breq	Edit_14_A
		cpi	temp1,Key_2
		breq	Edit_14_B
		cpi	temp1,Key_3
		breq	Edit_14_OK
		cpi	temp1,Key_4
		brne	Edit_14_NoKey
		rjmp	Edit_1
Edit_14_NoKey:
		sleep
		rjmp	Edit_14_Test_Key
Edit_14_A:
		lds	temp2,Time_Valid_A_Copy
		inc	temp2
		ldi	yl,low(Time_DTMF_Valid_A)
		ldi	yh,high(Time_DTMF_Valid_A)
		rcall	Read_EEPROM
;		subi	temp1,5
		cp	temp2,temp1
		brne	Edit_14_A_1
		ldi	temp2,MinPauseTime
Edit_14_A_1:
		sts	Time_Valid_A_Copy,temp2
		rjmp	Edit_14_1
Edit_14_B:
		lds	temp2,Time_Valid_B_Copy
		inc	temp2
		ldi	yl,low(Time_DTMF_Valid_B)
		ldi	yh,high(Time_DTMF_Valid_B)
		rcall	Read_EEPROM
;		subi	temp1,5
		cp	temp2,temp1
		brne	Edit_14_B_1
		ldi	temp2,MinPauseTime
Edit_14_B_1:
		sts	Time_Valid_B_Copy,temp2
		rjmp	Edit_14_1
Edit_14_OK:
		lds	temp1,Time_NoValid_A_Copy
		inc	temp1
		ldi	yl,low(Time_DTMF_NOvalid_A)
		ldi	yh,high(Time_DTMF_NOvalid_A)
		rcall	Write_EEPROM
		lds	temp1,Time_NoValid_B_Copy
		inc	temp1
		ldi	yl,low(Time_DTMF_NOvalid_B)
		ldi	yh,high(Time_DTMF_NOvalid_B)
		rcall	Write_EEPROM
		rjmp	Edit_1
;----
Calculate_Parameter:		
		push	temp2
		
		ldi	temp5,8
Calculate_Parameter_5:		
		mov	temp2,temp5
		rcall	Search_Seq_Start
		adiw	yl,Position_Flag_On
		rcall	Read_EEPROM
		tst	temp1
		breq	Calculate_Parameter_8
		
		sbiw	yl,Position_Flag_On-Position_DTMF_Length
		rcall	Read_EEPROM
		mov	xl,temp1
		adiw	yl,1
		rcall	Read_EEPROM
		mov	xh,temp1
		add	xl,xl
		adc	xh,xh
		adiw	yl,Position_Pause_Length-Position_DTMF_Length-1
		rcall	Read_EEPROM
		adiw	yl,1
		add	xl,temp1
		rcall	Read_EEPROM
		adc	xh,temp1
		ldi	temp2,8
Calculate_Parameter_6:
		rcall	Search_Seq_Start
		adiw	yl,Position_Flag_On
		rcall	Read_EEPROM
		tst	temp1
		breq	Calculate_Parameter_7

		sbiw	yl,Position_Flag_On-Position_Pause_Length-1
		rcall	Read_EEPROM
		mov	temp3,temp1
		mov	temp6,temp3
		sbiw	yl,1
		rcall	Read_EEPROM
		mov	temp4,temp1
		sub	temp1,xl
		sbc	temp3,xh
		brcc	Calculate_Parameter_7
		
		sbiw	yl,Position_Pause_Length-Position_DTMF_Length
		rcall	Read_EEPROM
		mov	temp3,temp1
		adiw	yl,1
		rcall	Read_EEPROM
		add	temp3,temp3
		adc	temp1,temp1
		add	temp4,temp3
		adc	temp6,temp1
		
		mov	temp1,temp4
		mov	temp3,temp6
		
		sub	temp1,xl
		sbc	temp3,xh
		brcs	Calculate_Parameter_7
		mov	xl,temp4
		mov	xh,temp6
Calculate_Parameter_7:
		dec	temp2
		brne	Calculate_Parameter_6
		
		mov	temp2,temp5
		rcall	Search_Seq_Start
		adiw	yl,Position_Timer_Wait
		mov	temp1,xl
		rcall	Write_EEPROM
		adiw	yl,1
		mov	temp1,xh
		rcall	Write_EEPROM
Calculate_Parameter_8:		
		dec	temp5
		brne	Calculate_Parameter_5
		
		pop	temp2
		ret
;   
;    RAM , temp2-  , edited_ch-  
;   temp5=0    (17-temp5)=  
Check_Sequence:
		ldi	temp5,Number_Sequence/2
Check_Sequence_1:
		lds	temp6,Sequence_Copy+Position_Number_Symbol
		ldi	xl,low(Sequence_Copy)
		ldi	xh,high(Sequence_Copy)
		cp	temp5,temp2
		breq	Check_Sequence_6	;      
Check_Sequence_2:
		ldi	yl,low(Sequence_table_A-Wide_Table)
		ldi	yh,high(Sequence_table_A-Wide_Table)
		tst	edited_ch
		breq	Check_Seq_Start_1
		ldi	yl,low(Sequence_table_B-Wide_Table)
		ldi	yh,high(Sequence_table_B-Wide_Table)
Check_Seq_Start_1:
		mov	temp1,temp5
Check_Seq_Start_2:
		adiw	yl,Wide_Table
		dec	temp1
		brne	Check_Seq_Start_2
		
		adiw	yl,Position_Number_Symbol
		rcall	Read_EEPROM
		sbiw	yl,Position_Number_Symbol
		tst	temp1
		breq	Check_Sequence_6	;       
		lds	temp4,Sequence_Copy+Position_Number_Symbol
		cp	temp4,temp1
		brcs	Check_Sequence_3
		mov	temp4,temp1	; temp4 -    ERROR
Check_Sequence_3:
		clr	temp3		;  
		mov	r0,temp1	;     
		ldi	zl,1		;  
Check_Sequence_4:
		rcall	Read_EEPROM
		ld	zh,x
		inc	temp3
		adiw	xl,1
		cp	temp1,zh
		breq	Check_Sequence_5	;-->   
		sub	xl,temp3
		sbc	xh,zero
		clr	temp3
Check_Sequence_5:
		cp	temp3,temp4
		breq	Check_Sequence_7	; (temp5)   
		adiw	yl,1
		inc	zl
		cp	r0,zl
		brcc	Check_Sequence_4	;-->     
		adiw	xl,1
		dec	temp6
		brne	Check_Sequence_2	;-->      
Check_Sequence_6:
		dec	temp5
		brne	Check_Sequence_1
Check_Sequence_7:
		ret
;  EEPROM  RAM    temp2- 
Copy_To_RAM:
		ldi	xl,low(Sequence_Copy)
		ldi	xh,high(Sequence_Copy)
		
		rcall	Search_Seq_Start
		
		ldi	zl,Wide_Table
Copy_To_RAM_3:
		rcall	Read_EEPROM
		st	x,temp1
		adiw	yl,1
		adiw	xl,1
		dec	zl
		brne	Copy_To_RAM_3
		ret
;1 
Menu_1:
		ldi	temp1,1		; 1-
		rcall	Copy_Screen
Menu_1_ForClock:
;        
		ldi	yl,low(Mode_A)
		ldi	yh,high(Mode_A)
		rcall	Read_EEPROM
		andi	temp1,0x7f
		ldi	zl,low(2*StringMode)
		ldi	zh,high(2*StringMode)
		lsl	temp1
		lsl	temp1
		add	zl,temp1
		adc	zh,zero
		ldi	temp1,14
		rcall	Print_String
;    B    
		ldi	yl,low(Mode_B)
		ldi	yh,high(Mode_B)
		rcall	Read_EEPROM
		andi	temp1,0x7f
		ldi	zl,low(2*StringMode)
		ldi	zh,high(2*StringMode)
		lsl	temp1
		lsl	temp1
		add	zl,temp1
		adc	zh,zero
		ldi	temp1,14+24
		rcall	Print_String
;    
		ldi	zl,low(2*StringO)
		ldi	zh,high(2*StringO)
		sbic	PIND,Control_Relay
		adiw	zl,2
		ldi	temp1,20
		rcall	Print_String
		
		ldi	zl,low(2*StringO)
		ldi	zh,high(2*StringO)
		sbis	PIND,Control_Relay
		adiw	zl,2
		ldi	temp1,20+24
		rcall	Print_String
		ret
;------------
;------------
;4   edited_ch-   0-A ff-B
Menu_4:
		ldi	temp1,4		; 4-
		rcall	Copy_Screen
		ldi	zl,low(2*StringCh)
		ldi	zh,high(2*StringCh)
		mov	temp1,edited_ch
		andi	temp1,2
		add	zl,temp1
		adc	zh,zero
		ldi	temp1,9
		rcall	Print_String	
;     B    
		lds	temp1,Mode_A_Copy
		cpse	edited_ch,zero
		lds	temp1,Mode_B_Copy
Menu_4_A1:
		mov	temp2,temp1
		
		andi	temp1,0x7f
		lsl	temp1
		lsl	temp1
		ldi	zl,low(2*StringMode)
		ldi	zh,high(2*StringMode)
		add	zl,temp1
		adc	zh,zero
		ldi	temp1,8+24
		rcall	Print_String
		rol	temp2
		sbc	temp2,temp2
;  
		ldi	yl,low(Sequence_table_A+Position_Flag_On)
		ldi	yh,high(Sequence_table_A+Position_Flag_On)
		tst	edited_ch
		breq	Menu_4_A2
		ldi	yl,low(Sequence_table_B+Position_Flag_On)
		ldi	yh,high(Sequence_table_B+Position_Flag_On)
Menu_4_A2:
		ldi	xh,8
		ldi	xl,11+24
Menu_4_A3:
		ldi	zl,low(2*StringAct)
		ldi	zh,high(2*StringAct)
		rcall	Read_EEPROM
		andi	temp1,0x03
		and	temp1,temp2
		add	zl,temp1
		adc	zh,zero
		add	zl,temp1
		adc	zh,zero
		mov	temp1,xl
		rcall	Print_String
		inc	xl
		adiw	yl,Wide_Table
		dec	xh
		brne	Menu_4_A3
		ret
;-5     temp2   
Menu_5:
		ldi	temp1,5		; 5-
		rcall	Copy_Screen
;     
		ldi	temp1,5
		rcall	Print_NoSequence
;       
		rcall	Search_Seq_Start
		adiw	yl,Position_Flag_On
		rcall	Read_EEPROM
		eor	temp1,edited_ch
		andi	temp1,0x03
		lsl	temp1
		lsl	temp1
		ldi	zl,low(2*StringCmd)
		ldi	zh,high(2*StringCmd)
		add	zl,temp1
		adc	zh,zero
		ldi	temp1,17
		rcall	Print_String
;      EMPTY
;  
Menu_5_A5:
		ldi	temp1,2+24	;   
		rcall	Print_Sequence
;  
		ldi	yl,low(Sequence_Copy+Position_DTMF_Length)
		ldi	yh,high(Sequence_Copy+Position_DTMF_Length)
		ldi	temp1,7
		rcall	Print_3Number
;  
		ldi	yl,low(Sequence_Copy+Position_Pause_Length)
		ldi	yh,high(Sequence_Copy+Position_Pause_Length)
		ldi	temp1,11
		rcall	Print_3Number
		ret
;------
;6   temp2-    1
Menu_6:
		ldi	temp1,6		; 6-
		rcall	Copy_Screen
		ldi	temp1,5
		rcall	Print_NoSequence
		
		ldi	temp1,2+24	;   
		rcall	Print_Sequence
		ret
;7    temp2-    1, (17-temp5)   
Menu_7:
		ldi	temp1,7		; 7-
		rcall	Copy_Screen
		push	temp2
		mov	temp2,temp5
		ldi	temp1,3+24
		rcall	Print_NoSequence
		ldi	temp1,5
		rcall	Print_Sequence
		
		ldi	xh,high(Err_Sequence_Copy)
		ldi	xl,low(Err_Sequence_Copy)
		ldi	yh,high(Sequence_Copy)
		ldi	yl,low(Sequence_Copy)
		ldi	temp1,Wide_Table
Menu_7_1:
		ld	r0,y
		st	x,r0
		adiw	yl,1
		adiw	xl,1
		dec	temp1
		brne	Menu_7_1
		
		rcall	Copy_To_RAM
		ldi	temp1,5+24
		rcall	Print_Sequence
		
		ldi	xh,high(Err_Sequence_Copy)
		ldi	xl,low(Err_Sequence_Copy)
		ldi	yh,high(Sequence_Copy)
		ldi	yl,low(Sequence_Copy)
		ldi	temp1,Wide_Table
Menu_7_2:
		ld	r0,x
		st	y,r0
		adiw	yl,1
		adiw	xl,1
		dec	temp1
		brne	Menu_7_2
		pop	temp2
		ret
;8   temp2-    1
Menu_8:
		ldi	temp1,8		; 8-
		rcall	Copy_Screen
		ldi	temp1,5
		rcall	Print_NoSequence
		
		ldi	temp1,2+24	;   
		rcall	Print_Sequence
;  
		ldi	yl,low(Sequence_Copy+Position_DTMF_Length)
		ldi	yh,high(Sequence_Copy+Position_DTMF_Length)
		ldi	temp1,12
		rcall	Print_3Number		
		ret
;9   temp2-    1
Menu_9:
		ldi	temp1,9		; 9-
		rcall	Copy_Screen
		ldi	temp1,5
		rcall	Print_NoSequence
		
		ldi	temp1,2+24	;   
		rcall	Print_Sequence
;  
		ldi	yl,low(Sequence_Copy+Position_Pause_Length)
		ldi	yh,high(Sequence_Copy+Position_Pause_Length)
		ldi	temp1,13
		rcall	Print_3Number
		ret
;10    temp2-    1
Menu_10:
		ldi	temp1,10	; 1-
		rcall	Copy_Screen
		ldi	temp1,3
		rcall	Print_NoSequence
		ldi	temp1,5
		rcall	Print_Sequence
;       
		ldi	yl,low(Sequence_Copy+Position_Flag_On)
		ldi	yh,high(Sequence_Copy+Position_Flag_On)
		ld	temp1,y
		eor	temp1,edited_ch
		andi	temp1,0x03
		lsl	temp1
		lsl	temp1
		ldi	zl,low(2*StringCmd)
		ldi	zh,high(2*StringCmd)
		add	zl,temp1
		adc	zh,zero
		ldi	temp1,15+24
		rcall	Print_String
		ret
;12   

;13    Valid_A  Valid_B
Menu_13:
		ldi	temp1,13		; 13-
		rcall	Copy_Screen
;  
		ldi	yl,low(Time_Valid_A_Copy)
		ldi	yh,high(Time_Valid_A_Copy)
		ldi	temp1,15
		rcall	Print_3Number
		ldi	yl,low(Time_Valid_B_Copy)
		ldi	yh,high(Time_Valid_B_Copy)
		ldi	temp1,15+24
		rcall	Print_3Number
		ret
;14    NoValid_A  NoValid_B
Menu_14:
		ldi	temp1,14		; 14-
		rcall	Copy_Screen
;  
		ldi	yl,low(Time_NoValid_A_Copy)
		ldi	yh,high(Time_NoValid_A_Copy)
		ldi	temp1,15
		rcall	Print_3Number
		ldi	yl,low(Time_NoValid_B_Copy)
		ldi	yh,high(Time_NoValid_B_Copy)
		ldi	temp1,15+24
		rcall	Print_3Number
		ret
;    temp1
Print_Time:
		mov	temp2,temp1
		ldi	yl,low(Clock_Hour)
		ldi	yh,high(Clock_Hour)
		rcall	Print_2Number
		ldi	yl,low(Clock_Min)
		ldi	yh,high(Clock_Min)
		ldi	temp1,3
		add	temp1,temp2
		rcall	Print_2Number
		ldi	yl,low(Clock_Sec)
		ldi	yh,high(Clock_Sec)
		ldi	temp1,6
		add	temp1,temp2
		rcall	Print_2Number
		ret
;      EEPROM      
; edited_ch -  temp2- 
;   yl - , temp1=0
Search_Seq_Start:
		ldi	yl,low(Sequence_table_A-Wide_Table)
		ldi	yh,high(Sequence_table_A-Wide_Table)
		tst	edited_ch
		breq	Search_Seq_Start_1

		ldi	yl,low(Sequence_table_B-Wide_Table)
		ldi	yh,high(Sequence_table_B-Wide_Table)
Search_Seq_Start_1:
		mov	temp1,temp2
Search_Seq_Start_2:
		adiw	yl,Wide_Table
		dec	temp1
		brne	Search_Seq_Start_2
		ret
;---   RAM  EEPROM    
Write_Sequence_ToEEPROM:
		rcall	Search_Seq_Start
		
		ldi	xl,low(Sequence_Copy)
		ldi	xh,high(Sequence_Copy)
		ldi	zh,Wide_Table
Write_STM_3:
		ld	temp1,x
		rcall	Write_EEPROM
		adiw	xl,1
		adiw	yl,1
		dec	zh
		brne	Write_STM_3
		ret
;-  EEPROM y-, temp1- 
Write_EEPROM:
		push	temp2
		push	temp1
		rcall	Read_EEPROM
		mov	temp2,temp1
		pop	temp1
		cp	temp1,temp2
		pop	temp2
		breq	Write_EEPROM_1
		out	EEARH,yh
		out	EEARL,yl
		out	EEDR,temp1
		cli
		sbi	EECR,EEMWE
		sbi	EECR,EEWE
		sei
Write_EEPROM_1:
		sbic	EECR,EEWE
		rjmp	Write_EEPROM_1
		
		ret
;------------
; EEPROM y-, temp1-   
Read_EEPROM:
;		sbic	EECR,EEWE
;		rjmp	Read_EEPROM
		out	EEARH,yh
		out	EEARL,yl
		cli
		sbi	EECR,EERE
		in	temp1,EEDR
		sei
		ret
;-------------
;     temp1- 
Copy_Screen:
		ldi	zl,low(2*Screen_1-48)
		ldi	zh,high(2*Screen_1-48)
		ldi	yh,48
Copy_Screen_1:
		add	zl,yh
		adc	zh,zero
		dec	temp1
		brne	Copy_Screen_1

		ldi	yl,low(RAM_Screen)
		ldi	yh,high(RAM_Screen)
		ldi	temp1,48
Copy_Screen_2:
		lpm
		st	y,r0
		adiw	zl,1
		adiw	yl,1
		dec	temp1
		brne	Copy_Screen_2
		
		ret
;---------  z-     temp1 -   
Print_String:
		push	yl
		push	yh

		ldi	yl,low(RAM_Screen)
		ldi	yh,high(RAM_Screen)
		add	yl,temp1
		adc	yh,zero
Print_String_1:
		lpm
		tst	r0
		breq	Print_String_2
		st	y,r0
		adiw	zl,1
		adiw	yl,1
		rjmp	Print_String_1
Print_String_2:
		pop	yh
		pop	yl
		ret
;-      temp1- temp2- 
Print_NoSequence:
		ldi	zl,low(2*StringN)
		ldi	zh,high(2*StringN)
		add	zl,temp2
		adc	zh,zero
		add	zl,temp2
		adc	zh,zero
		rcall	Print_String
		ret
;    temp1- y-  RAM
;  temp1 - 
Print_Sequence:
		push	xl
		push	xh
		
		mov	xl,temp1
		ldi	xh,16
Print_Sequence_3:
		ldi	zl,low(2*StringAct)
		ldi	zh,high(2*StringAct)
		rcall	Print_String
		inc	temp1
		dec	xh
		brne	Print_Sequence_3
		
		lds	temp1,Sequence_Copy+Position_Number_Symbol
		tst	temp1
		brne	Print_Sequence_4
		ldi	zl,low(2*StringEmpty)
		ldi	zh,high(2*StringEmpty)
		mov	temp1,xl		;   
		rcall	Print_String
		rjmp	Print_Sequence_6
Print_Sequence_4:	
		mov	xh,temp1
		ldi	yl,low(Sequence_Copy)
		ldi	yh,high(Sequence_Copy)
Print_Sequence_5:
		ld	temp1,y
		ldi	zl,low(2*StringN)
		ldi	zh,high(2*StringN)
		add	zl,temp1
		adc	zh,zero
		add	zl,temp1
		adc	zh,zero
		mov	temp1,xl
		rcall	Print_String
		inc	xl
		adiw	yl,1
		dec	xh
		brne	Print_Sequence_5
Print_Sequence_6:
		pop	xh
		pop	xl
		ret
;-   3-   -   RAM    temp1- 
Print_3Number:
		push	xl
		push	xh
		
		mov	xh,temp1
		ld	xl,y
		adiw	yl,1
		ld	yh,y
		mov	yl,xl		;  y-  
		ldi	temp1,100
		rcall	DivY
		tst	temp1
		brne	Print_3Number_1
		ldi	temp1,16
Print_3Number_1:
		ldi	zl,low(2*StringN)
		ldi	zh,high(2*StringN)
		mov	xl,temp1
		add	zl,temp1
		adc	zh,zero
		add	zl,temp1
		adc	zh,zero
		mov	temp1,xh
		rcall	Print_String
		inc	xh
		ldi	temp1,10
		rcall	DivY
		tst	temp1
		brne	Print_3Number_2
		ldi	temp1,16
Print_3Number_2:
		cpi	temp1,16
		brne	Print_3Number_3
		cpi	xl,16
		breq	Print_3Number_3
		ldi	temp1,0x0a
Print_3Number_3:
		ldi	zl,low(2*StringN)
		ldi	zh,high(2*StringN)
		add	zl,temp1
		adc	zh,zero
		add	zl,temp1
		adc	zh,zero
		mov	temp1,xh
		rcall	Print_String
		inc	xh
		tst	yl
		brne	Print_3Number_4
		ldi	yl,0x0a
Print_3Number_4:
		ldi	zl,low(2*StringN)
		ldi	zh,high(2*StringN)
		add	zl,yl
		adc	zh,zero
		add	zl,yl
		adc	zh,zero
		mov	temp1,xh
		rcall	Print_String
		
		pop	xh
		pop	xl
		ret
;-   2-     -   RAM    temp1- 
Print_2Number:
		push	temp1
		
		ld	yl,y
		mov	yh,zero
		ldi	temp1,10
		rcall	DivY
		tst	temp1
		brne	Print_2Number_1
		ldi	temp1,18
Print_2Number_1:
		ldi	zl,low(2*StringN)
		ldi	zh,high(2*StringN)
		add	zl,temp1
		adc	zh,zero
		add	zl,temp1
		adc	zh,zero
		pop	temp1
		rcall	Print_String
		inc	temp1
		tst	yl
		brne	Print_2Number_2
		ldi	yl,18
Print_2Number_2:
		ldi	zl,low(2*StringN)
		ldi	zh,high(2*StringN)
		add	zl,yl
		adc	zh,zero
		add	zl,yl
		adc	zh,zero
		rcall	Print_String
		
		ret
;---- y- , temp1-.temp1-
DivY:
		push	temp2
		mov	temp2,temp1
		ser	temp1
DivY_1:		
		sub	yl,temp2
		sbc	yh,zero
		inc	temp1
		brcc	DivY_1
		add	yl,temp2
		adc	yh,zero
		pop	temp2
		ret
;---------
;    
RAM_To_LCD:
		push	xl
		push	xh
		push	temp2
		push	temp1
;    		
		ldi	temp1,0x80	;    DDRAM=0
		rcall	Command_To_LCD
		ldi	xl,low(RAM_Screen)
		ldi	xh,high(RAM_Screen)
		ldi	temp2,24
RAM_To_LCD_1:
		ld	temp1,x
		rcall	Data_To_LCD
		adiw	xl,1
		dec	temp2
		brne	RAM_To_LCD_1
;    
		ldi	temp1,0xc0	;    DDRAM=40h
		rcall	Command_To_LCD
		ldi	temp2,24
RAM_To_LCD_2:
		ld	temp1,x
		rcall	Data_To_LCD
		adiw	xl,1
		dec	temp2
		brne	RAM_To_LCD_2

		pop	temp1
		pop	temp2
		pop	xh
		pop	xl
		ret
;-     
LCD_Init:
		cbi	PORTD,RS
		cbi	PORTD,RdnWr
		cbi	PORTD,E
; 15 
		ldi	temp1,150
		rcall	Wait_N
LCD_Init_1:		
		ldi	temp1,0x30
		rcall	Command_To_LCD_NoBF
;		ldi	temp1,50
;LCD_Init_2:		
		rcall	Wait_N50

		ldi	temp1,0x30
		rcall	Command_To_LCD_NoBF

		ldi	temp1,0x30
		rcall	Command_To_LCD_NoBF

		ldi	temp1,0x3f		; 8  2  5x10
		rcall	Command_To_LCD_NoBF
		ldi	temp1,0x08		;    
		rcall	Command_To_LCD
		ldi	temp1,0x01		;     0   0,    
		rcall	Command_To_LCD
;		ldi	temp1,50
;LCD_Init_3:		
		rcall	Wait_N50
		
		ldi	temp1,0x06		;     
		rcall	Command_To_LCD
		ldi	temp1,0x3f		
		rcall	Command_To_LCD
		ldi	temp1,0x08
		rcall	Command_To_LCD
		ldi	temp1,0x0c		;    
		rcall	Command_To_LCD
		ldi	temp1,0x06
		rcall	Command_To_LCD
		ret
;-  2-^,4-v,6->
Write_Character:
		ldi	zl,low(2*Character)
		ldi	zh,high(2*Character)
		ldi	xh,3
		ldi	xl,0x50
Write_Character_1:
		ldi	yl,11
Write_Character_2:
		mov	temp1,xl
		rcall	Command_To_LCD
		lpm
		mov	temp1,r0
		rcall	Data_To_LCD
		inc	xl
		adiw	zl,1
		dec	yl
		brne	Write_Character_2
		adiw	zl,1
		adiw	xl,0x5
		dec	xh
		brne	Write_Character_1
		ret				
;-     ,  -  temp1
Command_To_LCD:
;		rcall	LCD_Busy
Command_To_LCD_NoBF:
		cbi	PORTD,RdnWr
		cbi	PORTD,RS
		cbi	PORTD,RS
		
		out	PORTB,temp1
		out	PORTB,temp1
		
		sbi	PORTD,E
		sbi	PORTD,E
		sbi	PORTD,E
		sbi	PORTD,E
		cbi	PORTD,E
		rjmp	Wait_100mks

;-  N*100
Wait_N50:
		ldi	temp1,50
Wait_N:
		rcall	Wait_100mks
		dec	temp1
		brne	Wait_N
		ret
;-     		
Data_To_LCD:
;		rcall	LCD_Busy
		cbi	PORTD,RdnWr
		sbi	PORTD,RS
		sbi	PORTD,RS
		
		out	PORTB,temp1
		out	PORTB,temp1
		sbi	PORTD,E
		sbi	PORTD,E
		sbi	PORTD,E
		sbi	PORTD,E
		cbi	PORTD,E	
;-  100
Wait_100mks:
		push	temp1
		ldi	temp1,Quartz/4000*100-3	; q/4000*Tmks-3
Wait_100mks_loop:
		dec	temp1
		nop
		brne	Wait_100mks_loop
		nop
		pop	temp1
		ret
;-   
;LCD_Busy:
;		push	temp1
;		cbi	PORTD,RS
;		out	PORTB,zero
;		out	DDRB,zero
;		ser	temp1
;		out	PORTB,temp1
;LCD_Busy_1:
;		cbi	PORTD,E
;		cbi	PORTD,E
;		cbi	PORTD,E
;		cbi	PORTD,E
;		cbi	PORTD,E
;		sbi	PORTD,RdnWr
;		sbi	PORTD,RdnWr
;		sbi	PORTD,E
;		sbi	PORTD,E
;		sbi	PORTD,E
;		sbi	PORTD,E
;		sbi	PORTD,E
;		sbic	PINB,Busy
;		rjmp	LCD_Busy_1

;		cbi	PORTD,E
;		cbi	PORTD,RdnWr
;		out	DDRB,temp1

;		pop	temp1
;		ret
;
Screen_1:
.db	"Edit1    Mode:       Ch1"
.db	"Edit2    Mode:       Ch2"
Screen_2:
.db	"Edit1  Manual Mode   Ch1"
.db	"Edit2   Channel:2  ",255,"Auto"
Screen_3:
.db	"Edit1  Manual Mode ",255,"Auto"
.db	"Edit2   Channel:1    Ch2"
Screen_4:
.db	" Channel:  12345678 Edit"
.db	"SetMode:             Ret"
Screen_5:
.db	0x02," No:     /   ms     New"
.db	0x04,"                    Ret"
Screen_6:
.db	0x02," No:  Codestring      ",0x06
.db	0x04,"                    Ret"
Screen_7:
.db	"Err:                  Ok"
.db	"No:                     "
Screen_8:
.db	0x02," No:  Tone:   ms     Ok"
.db	0x04,"                    Ret"
Screen_9:
.db	0x02," No:  Pause:   ms    Ok"
.db	0x04,"                    Ret"
Screen_10:
.db	"No:                   Ok"
.db	"SelectCommand:       Ret"
Screen_11:
.db	"  :  :   Mode:       Ch1"
.db	"SetTime  Mode:       Ch2"
Screen_12:
.db	"SetHour   :  :OO  SetMin"
.db	"Ret                   Ok"
Screen_13:
.db	"SetPresentTime1   ms  Ok"
.db	"SetPresentTime2   ms Ret"
Screen_14:
.db	"SetAbsentTime1    ms  Ok"
.db	"SetAbsentTime2    ms Ret"
Screen_15:
.db	"TimeCorrect       s   Ok"
.db	"ValueCorrect      s  Ret"
;---- 
StringMode:
.db	"Off",0
.db	"=  ",0
.db	"T  ",0
.db	"   ",0
.db	"   ",0
.db	"E= ",0
.db	"ET ",0
;----
StringCmd:
.db	"Off",0
.db	"On1",0
.db	"On2",0
.db	"Off",0
;-----
StringO:
.db	0xff,0
.db	" ",0
;-----
StringCh:
.db	"1",0
.db	"2",0
;-----
StringAct:
.db	" ",0
.db	0xd9,0
.db	0xda,0
;----
StringN:
.db	"D",0,"1",0,"2",0,"3",0,"4",0,"5",0,"6",0,"7",0
.db	"8",0,"9",0,"0",0,"*",0,"#",0,"A",0,"B",0,"C",0
.db	" ",0,0x7e,0,"O",0
StringEmpty:
.db	"Empty",0
String16Space:
.db	"                ",0,0
;----
Character:
;^
.db	4,4,14,14,31,31,0,0,0,0,0,0
;v
.db	0,0,31,31,14,14,4,4,0,0,0,0
;>
.db	0,16,24,28,30,28,24,16,0,0,0,0